# Copyright 2016-2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at http://boost.org/LICENSE_1_0.txt)

version: 1.0.{build}-{branch}

shallow_clone: true

branches:
  only:
    - master
    - develop
    - /feature\/.*/

environment:
  matrix:

    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2015
      TOOLSET: msvc-12.0

    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2017
      TOOLSET: msvc-14.0

    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2017
      TOOLSET: msvc-14.1
      CXXSTD: 14,17,latest

    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2015
      CMAKE: 1
      CONFIG: MinSizeRel

    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2015
      CMAKE_SUBDIR: 1
    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2015
      CMAKE_INSTALL: 1

    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2017
      CMAKE: 1
      CONFIG: MinSizeRel

    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2017
      CMAKE_SUBDIR: 1
    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2017
      CMAKE_INSTALL: 1

    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2019
      CMAKE: 1
      CONFIG: MinSizeRel

    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2019
      CMAKE_SUBDIR: 1
    - APPVEYOR_BUILD_WORKER_IMAGE: Visual Studio 2019
      CMAKE_INSTALL: 1

install:
  - set BOOST_BRANCH=develop
  - if "%APPVEYOR_REPO_BRANCH%" == "master" set BOOST_BRANCH=master
  - cd ..
  - git clone -b %BOOST_BRANCH% --depth 1 https://github.com/boostorg/boost.git boost-root
  - cd boost-root
  - git submodule update --init tools/boostdep
  - xcopy /s /e /q %APPVEYOR_BUILD_FOLDER% libs\mp11\
  - python tools/boostdep/depinst/depinst.py mp11
  - cmd /c bootstrap
  - b2 -d0 headers

build: off

test_script:
  - if not "%CXXSTD%" == "" set CXXSTD=cxxstd=%CXXSTD%
  - if "%CMAKE%%CMAKE_SUBDIR%%CMAKE_INSTALL%" == ""  b2 -j3 libs/mp11/test toolset=%TOOLSET% %CXXSTD% address-model=32,64 variant=debug,release embed-manifest-via=linker

  - if not "%CMAKE%" == ""  mkdir __build__ && cd __build__
  - if not "%CMAKE%" == ""  cmake -DBUILD_TESTING=ON -DBOOST_INCLUDE_LIBRARIES=mp11 ..
  - if not "%CMAKE%" == ""  cmake --build . --target tests --config %CONFIG%
  - if not "%CMAKE%" == ""  ctest --output-on-failure --no-tests=error -C %CONFIG%

  - if not "%CMAKE_SUBDIR%" == ""  cd libs/mp11/test/cmake_subdir_test && mkdir __build__ && cd __build__
  - if not "%CMAKE_SUBDIR%" == ""  cmake ..
  - if not "%CMAKE_SUBDIR%" == ""  cmake --build . --config Debug && cmake --build . --target check --config Debug
  - if not "%CMAKE_SUBDIR%" == ""  cmake --build . --config Release && cmake --build . --target check --config Release

  - if not "%CMAKE_INSTALL%" == ""  cd libs/mp11 && mkdir __build__ && cd __build__
  - if not "%CMAKE_INSTALL%" == ""  cmake -DCMAKE_INSTALL_PREFIX=C:/cmake-prefix ..
  - if not "%CMAKE_INSTALL%" == ""  cmake --build . --target install --config Debug
  - if not "%CMAKE_INSTALL%" == ""  cmake --build . --target install --config Release
  - if not "%CMAKE_INSTALL%" == ""  cd ../test/cmake_install_test && mkdir __build__ && cd __build__
  - if not "%CMAKE_INSTALL%" == ""  cmake -DCMAKE_INSTALL_PREFIX=C:/cmake-prefix ..
  - if not "%CMAKE_INSTALL%" == ""  cmake --build . --config Debug && cmake --build . --target check --config Debug
  - if not "%CMAKE_INSTALL%" == ""  cmake --build . --config Release && cmake --build . --target check --config Release
